package VASL.build.module;

import VASSAL.build.AbstractConfigurable;
import VASSAL.build.Buildable;
import VASSAL.build.GameModule;
import VASSAL.build.module.documentation.HelpFile;

import javax.swing.*;
import java.awt.*;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.util.Iterator;

public class NewDice extends AbstractConfigurable {
    ASLChatter saslchat = null;
    public NewDice() {
        for (Iterator<Buildable> e = GameModule.getGameModule().getBuildables().iterator();
             e.hasNext();) {
            Object o = e.next();
            if (o instanceof ASLChatter) {
                saslchat = (ASLChatter) o;
                break;
            }
        }
        JPanel saslp = saslchat.getButtonPanel();
        JLabel emptylabel = new JLabel();
        emptylabel.setText("                   ");
        emptylabel.setBorder(null);
        saslp.add(emptylabel);
        JButton m_btnEP = saslchat.CreateChatterDiceButton("", "Action", "Enemy Action DR", KeyStroke.getKeyStroke(KeyEvent.VK_A, InputEvent.CTRL_DOWN_MASK + InputEvent.SHIFT_DOWN_MASK), true, "EP");
        m_btnEP.setBackground(new Color(165, 165, 165));
        JButton m_btnEA = saslchat.CreateChatterDiceButton("", "AC", "Enemy Activation dr", KeyStroke.getKeyStroke(KeyEvent.VK_B, InputEvent.CTRL_DOWN_MASK + InputEvent.SHIFT_DOWN_MASK), false, "AC");
        m_btnEA.setBackground(new Color(165, 165, 165));
        JButton m_btnRE = saslchat.CreateChatterDiceButton("", "RE", "Enemy RE DR", KeyStroke.getKeyStroke(KeyEvent.VK_E, InputEvent.CTRL_DOWN_MASK + InputEvent.SHIFT_DOWN_MASK), true, "E RE");
        m_btnRE.setBackground(new Color(165, 165, 165));
        JButton m_btnCMD = saslchat.CreateChatterDiceButton("", "CMD", "Friendly CMD DR", KeyStroke.getKeyStroke(KeyEvent.VK_F, InputEvent.CTRL_DOWN_MASK + InputEvent.SHIFT_DOWN_MASK), true, "CMD");
        m_btnCMD.setBackground(new Color(82, 165, 82));
        JButton m_btnFRE = saslchat.CreateChatterDiceButton("", "RE", "Friendly RE DR", KeyStroke.getKeyStroke(KeyEvent.VK_E, InputEvent.CTRL_DOWN_MASK + InputEvent.SHIFT_DOWN_MASK), true, "F RE");
        m_btnFRE.setBackground(new Color(82, 165, 82));

        GridBagConstraints l_objGridBagConstraints = new GridBagConstraints();
        l_objGridBagConstraints.fill = GridBagConstraints.BOTH;
        l_objGridBagConstraints.weightx = 0.5;
        l_objGridBagConstraints.weighty = 0.5;
        l_objGridBagConstraints.insets = new Insets(0, 1, 0, 1);
        saslp.add(m_btnEP, l_objGridBagConstraints );
        saslp.add(m_btnEA, l_objGridBagConstraints);
        saslp.add(m_btnRE, l_objGridBagConstraints);
        saslp.add(m_btnCMD, l_objGridBagConstraints);
        saslp.add(m_btnFRE, l_objGridBagConstraints);
    }
    public Class<?>[] getAttributeTypes() {
        return new Class<?>[] {String.class};
    }

    @Override
    public String[] getAttributeNames() {
        return new String[] {"Name"};
    }

    @Override
    public String[] getAttributeDescriptions() {
        return new String[] {"Name"};
    }

    @Override
    public String getAttributeValueString(String key) {

        return "SASL Dice Buttons";
    }

    @Override
    public void setAttribute(String key, Object value) {
    }
    @Override
    public void addTo(Buildable parent) {

    }
    @Override
    public void removeFrom(Buildable parent) {

    }
    @Override
    public HelpFile getHelpFile() {
        return null;
    }
    @Override
    public Class[] getAllowableConfigureComponents() {
        return new Class[0];
    }
}
